//
//  YYLabel+adjustFontSizeToBounds.m
//  Demo_Video
//
//  Created by Melody on 2019/8/16.
//  Copyright © 2019 duowan. All rights reserved.
//

#import "YYLabel+adjustFontSizeToBounds.h"

@implementation YYLabel (adjustFontSizeToBounds)

- (CGFloat)getMaxLengthTextFontSize:(NSString *)text {
    
    //从最大字号放缩到最小字号
    int fontSize = 55;
    int minFontSize = 1;
    
    CGSize constraintSize;
    CGSize textSize;
    if (self.isVerticalForm) {
        constraintSize = CGSizeMake(MAXFLOAT, CGRectGetHeight(self.bounds));
    }else{
        constraintSize = CGSizeMake(CGRectGetWidth(self.bounds), MAXFLOAT);
    }
    
    do {
        self.font = [UIFont fontWithName:self.font.fontName size:fontSize];
        
        YYTextContainer *container = [self valueForKey:@"_innerContainer"];
        if (container) {
            container = container.copy;
        } else {
            container = [YYTextContainer new];
            container.insets = self.textContainerInset;
            container.exclusionPaths = self.exclusionPaths;
            container.verticalForm = self.verticalForm;
            container.maximumNumberOfRows = self.numberOfLines;
            container.linePositionModifier = self.linePositionModifier;
        }
        
        //获得当前字号所需的label大小
        container.size = constraintSize; // 大小限定
        NSDictionary *attributes = [NSDictionary dictionaryWithObject:self.font
                                                               forKey:NSFontAttributeName];
        NSAttributedString *string = [[NSAttributedString alloc]initWithString:text attributes:attributes];
        textSize = [YYTextLayout layoutWithContainer:container text:string].textBoundingSize;
        //textSize = [self sizeThatFits:constraintSize];
        
        // 如果估算label大小小于原Label的大小,则找到,否则缩小字号继续寻找
        if (self.isVerticalForm) {
            if( textSize.width <= CGRectGetWidth(self.bounds)){
                break;
            }
        }else{
            /// +1.5 预防部分字幕个数导致计算有误差
            if( (textSize.height + 1.5) < CGRectGetHeight(self.bounds)){
                break;
            }
        }
        fontSize -= 1;
        
    } while (fontSize > minFontSize);
    
    return fontSize;
    
}

- (void)adjustFontSizeToFitBounds
{
    //从最大字号放缩到最小字号
    int fontSize = 55;
    int minFontSize = 1;
    
    CGSize constraintSize;
    CGSize textSize;
    if (self.isVerticalForm) {
        constraintSize = CGSizeMake(MAXFLOAT, CGRectGetHeight(self.bounds));
    }else{
        constraintSize = CGSizeMake(CGRectGetWidth(self.bounds), MAXFLOAT);
    }
    
    do {
        self.font = [UIFont fontWithName:self.font.fontName size:fontSize];
        
        YYTextContainer *container = [self valueForKey:@"_innerContainer"];
        if (container) {
            container = container.copy;
        } else {
            container = [YYTextContainer new];
            container.insets = self.textContainerInset;
            container.exclusionPaths = self.exclusionPaths;
            container.verticalForm = self.verticalForm;
            container.maximumNumberOfRows = self.numberOfLines;
            container.linePositionModifier = self.linePositionModifier;
        }
        
        //获得当前字号所需的label大小
        container.size = constraintSize; // 大小限定
        NSDictionary *attributes = [NSDictionary dictionaryWithObject:self.font
                                                               forKey:NSFontAttributeName];
        NSAttributedString *string = [[NSAttributedString alloc]initWithString:self.text attributes:attributes];
        textSize = [YYTextLayout layoutWithContainer:container text:string].textBoundingSize;
        //textSize = [self sizeThatFits:constraintSize];
        
        // 如果估算label大小小于原Label的大小,则找到,否则缩小字号继续寻找
        if (self.isVerticalForm) {
            if( textSize.width <= CGRectGetWidth(self.bounds)){
                break;
            }
        }else{
            /// +1.5 预防部分字幕个数导致计算有误差
            if( (textSize.height + 1.5) < CGRectGetHeight(self.bounds)){
                break;
            }
        }
        fontSize -= 1;
        
    } while (fontSize > minFontSize);
    
    //如果只有一行 则居中
//    if (self.isVerticalForm) {
//        if (floor((textSize.width / self.font.pointSize)) == 1) {
            self.textAlignment = NSTextAlignmentCenter;
//        }else{
//            self.textAlignment = NSTextAlignmentLeft;
//        }
//    }else{
//        if (floor((textSize.height / self.font.lineHeight)) == 1) {
//            self.textAlignment = NSTextAlignmentCenter;
//        }else{
//            self.textAlignment = NSTextAlignmentLeft;
//        }
//    }
    
}

@end
